'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = initAppManager;

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

var _slotFinder = require('slot-finder');

var _slotFinder2 = _interopRequireDefault(_slotFinder);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initAppManager(w) {
  var _class, _temp, _initialiseProps;

  return _temp = _class = function () {
    (0, _createClass3.default)(AppManager, null, [{
      key: '_getBrowserPath',
      value: function _getBrowserPath() {
        return w.location.pathname;
      }
    }, {
      key: '_timeout',
      value: function _timeout() {
        var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DEFAULT_TIMEOUT;

        return new _promise2.default(function (resolve) {
          return setTimeout(resolve, timeout);
        });
      }
    }, {
      key: '_goToPath',
      value: function _goToPath() {
        w.location.href = AppManager._getBrowserPath(); // eslint-disable-line no-param-reassign
      }
    }, {
      key: '_getPathCheckers',
      value: function _getPathCheckers(apps) {
        return (0, _keys2.default)(apps || {}).reduce(function (appPathCheckers, appName) {
          var appPath = apps[appName].appPath;


          if (!appPath || typeof appPath !== 'string') {
            return appPathCheckers;
          }

          return (0, _assign2.default)({}, appPathCheckers, (0, _defineProperty3.default)({}, appName, (0, _pathToRegexp2.default)(appPath)));
        }, {});
      }
    }]);

    function AppManager(config, events) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      (0, _classCallCheck3.default)(this, AppManager);

      _initialiseProps.call(this);

      if (!config) {
        throw new Error('Config not specified. Aborting.');
      }

      if (!w.document || !w.location || !w.history) {
        throw new Error('Invalid window object. Aborting.');
      }

      var apps = config.apps,
          slots = config.slots,
          fragments = config.fragments;


      this._apps = apps;
      this._slots = slots;
      this._fragments = fragments;
      this._events = events;
      this._options = options;
      this._pathCheckers = this.constructor._getPathCheckers(this._apps);
    }

    (0, _createClass3.default)(AppManager, [{
      key: '_shimHistory',
      value: function _shimHistory() {
        var _this = this;

        /* eslint-disable no-param-reassign */

        var onpopstate = w.onpopstate,
            onbeforeunload = w.onbeforeunload;
        var _w$history = w.history,
            pushState = _w$history.pushState,
            replaceState = _w$history.replaceState;


        w.history.pushState = function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          if (typeof pushState === 'function') {
            pushState.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_PUSH_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_PUSH_STATE);
        };

        w.history.replaceState = function () {
          for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          if (typeof replaceState === 'function') {
            replaceState.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_REPLACE_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_REPLACE_STATE);
        };

        // $FlowFixMe
        w.history.getState = function () {
          return {
            data: w.history.state,
            title: w.document.title,
            url: w.location.href
          };
        };

        w.onpopstate = function () {
          for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          if (typeof onpopstate === 'function') {
            onpopstate.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_POP_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_POP_STATE);
        };

        w.onbeforeunload = function () {
          for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
          }

          if (typeof onbeforeunload === 'function') {
            onbeforeunload.apply(w.history, args);
          }

          _this.removeListener(_this.constructor.eventTitles.HISTORY_STATE_CHANGE, _this._handleStateChange);
          _this.removeListener(_this.constructor.eventTitles.STATUS_CHANGE, _this._handleUpdateStatus);

          w.onpopstate = onpopstate;
          w.history.pushState = pushState;
          w.history.replaceState = replaceState;
        };

        this.on(this.constructor.eventTitles.HISTORY_STATE_CHANGE, this._handleStateChange);
        this.on(this.constructor.eventTitles.STATUS_CHANGE, this._handleUpdateStatus);
      }
    }]);
    return AppManager;
  }(), _class.statuses = _constants.statuses, _class.eventTitles = _constants.eventTitles, _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this._status = this.constructor.statuses.UNINITIALISED;
    this._currentAppName = null;
    this._resolvedFragments = {};

    this.emit = function (eventTitle, data) {
      if (_this2._events && typeof _this2._events.emit === 'function') {
        _this2._events.emit(eventTitle, data);
      }
    };

    this.on = function (eventTitle, listener) {
      if (_this2._events && typeof _this2._events.on === 'function') {
        _this2._events.on(eventTitle, listener);
      }
    };

    this.removeListener = function (eventTitle, listener) {
      if (_this2._events && typeof _this2._events.removeListener === 'function') {
        _this2._events.removeListener(eventTitle, listener);
      }
    };

    this._setStatus = function (newStatus) {
      if (_this2._status !== newStatus) {
        _this2._status = newStatus;
        _this2.emit(_this2.constructor.eventTitles.STATUS_CHANGE, newStatus);
      }
    };

    this._onError = function (title, id, err) {
      _this2._setStatus(_this2.constructor.statuses.ERROR);
      _this2.emit(_this2.constructor.eventTitles.ERROR, { title: title, id: id, err: err });
    };

    this._getAppFromPath = function () {
      var path = _this2.constructor._getBrowserPath();

      if (!path || typeof path !== 'string') {
        _this2._onError('get_app_from_path.no_path');

        return null;
      }

      return (0, _keys2.default)(_this2._pathCheckers).find(function (appName) {
        var pathChecker = _this2._pathCheckers[appName];

        if (!pathChecker) {
          _this2._onError('get_app_from_path.invalid_appPath', appName);

          return false;
        }

        return pathChecker.exec(path);
      });
    };

    this._getSlotElement = function (slotName) {
      var slot = _this2._slots[slotName];

      if (!slot) {
        _this2._onError('get_slot_element.no_slot', slotName);

        return null;
      }

      var element = w.document.querySelector('.' + slot.elementClass);

      if (!element) {
        _this2._onError('get_slot_element.no_element', slotName);

        return null;
      }

      return element;
    };

    this._loadFragmentScript = function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(fragmentName) {
        var fragment, _script;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                fragment = _this2._fragments[fragmentName];

                if (fragment) {
                  _context.next = 4;
                  break;
                }

                _this2._onError('load_fragment_script.invalid_fragment', fragmentName);

                return _context.abrupt('return', null);

              case 4:
                if (!(typeof fragment.load !== 'function')) {
                  _context.next = 7;
                  break;
                }

                _this2._onError('load_fragment_script.not_function', fragmentName);

                return _context.abrupt('return', null);

              case 7:
                _context.prev = 7;
                _context.next = 10;
                return _promise2.default.race([fragment.load(), _this2.constructor._timeout(_this2._options.importTimeout)]);

              case 10:
                _script = _context.sent;

                if (_script) {
                  _context.next = 14;
                  break;
                }

                _this2._onError('load_fragment_script.no_script', fragmentName);

                return _context.abrupt('return', null);

              case 14:
                if ('version' in _script) {
                  _context.next = 17;
                  break;
                }

                _this2._onError('load_fragment_script.invalid_script', fragmentName);

                return _context.abrupt('return', null);

              case 17:
                return _context.abrupt('return', _script);

              case 20:
                _context.prev = 20;
                _context.t0 = _context['catch'](7);

                _this2._onError('load_fragment_script.load', fragmentName, _context.t0);

                return _context.abrupt('return', null);

              case 24:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2, [[7, 20]]);
      }));

      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }();

    this._resolveFragment = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(slotName, fragmentName) {
        var script, resolvedFragment;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!_this2._resolvedFragments[fragmentName]) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return', _this2._resolvedFragments[fragmentName]);

              case 2:
                _context2.next = 4;
                return _this2._loadFragmentScript(fragmentName);

              case 4:
                script = _context2.sent;

                if (script) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt('return', null);

              case 7:
                resolvedFragment = { script: script, slot: slotName, name: fragmentName };


                _this2._resolvedFragments[fragmentName] = resolvedFragment;

                return _context2.abrupt('return', resolvedFragment);

              case 10:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x4, _x5) {
        return _ref2.apply(this, arguments);
      };
    }();

    this._resolvePageFragments = function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(appName) {
        var app, appFragments, emptySlots, pageFragments, resolveFragmentPromises;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                app = _this2._apps[appName];

                if (Array.isArray(app.fragments)) {
                  _context3.next = 4;
                  break;
                }

                _this2._onError('resolve_page_fragments.invalid_app', appName);

                return _context3.abrupt('return', null);

              case 4:
                appFragments = app.fragments.map(function (fragmentName) {
                  return _this2._fragments[fragmentName];
                }).filter(function (fragment) {
                  return fragment.managed;
                }).map(function (_ref4) {
                  var name = _ref4.name,
                      slots = _ref4.slots;
                  return { name: name, slots: slots };
                });
                emptySlots = (0, _keys2.default)(_this2._slots).reduce(function (empty, slotName) {
                  return (0, _assign2.default)(empty, (0, _defineProperty3.default)({}, slotName, null));
                }, {});
                pageFragments = (0, _slotFinder2.default)(emptySlots, appFragments);

                if (!(!pageFragments || (typeof pageFragments === 'undefined' ? 'undefined' : (0, _typeof3.default)(pageFragments)) !== 'object')) {
                  _context3.next = 10;
                  break;
                }

                _this2._onError('resolve_page_fragments.get', appName);

                return _context3.abrupt('return', null);

              case 10:
                resolveFragmentPromises = (0, _keys2.default)(pageFragments).filter(function (slotName) {
                  return pageFragments[slotName];
                }).map(function (slotName) {
                  return _this2._resolveFragment(slotName, pageFragments[slotName]);
                });
                return _context3.abrupt('return', _promise2.default.all(resolveFragmentPromises));

              case 12:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this2);
      }));

      return function (_x6) {
        return _ref3.apply(this, arguments);
      };
    }();

    this._hydrate = function (appName) {
      return function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(resolvedFragment) {
          var script, name, slot, slotElement, app;
          return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  script = resolvedFragment.script, name = resolvedFragment.name, slot = resolvedFragment.slot;
                  _context4.prev = 1;
                  slotElement = _this2._getSlotElement(slot);

                  if (slotElement) {
                    _context4.next = 6;
                    break;
                  }

                  _this2._onError('hydrate.missing_element', slot);

                  return _context4.abrupt('return', false);

                case 6:
                  if (!(typeof script.hydrate !== 'function')) {
                    _context4.next = 9;
                    break;
                  }

                  _this2._onError('hydrate.invalid_script', name || appName);

                  return _context4.abrupt('return', false);

                case 9:
                  app = _this2._apps[appName];

                  if (!(script.version === 3)) {
                    _context4.next = 15;
                    break;
                  }

                  _context4.next = 13;
                  return script.hydrate(slotElement, w.history, app);

                case 13:
                  _context4.next = 17;
                  break;

                case 15:
                  _context4.next = 17;
                  return script.hydrate(slotElement, app);

                case 17:
                  return _context4.abrupt('return', true);

                case 20:
                  _context4.prev = 20;
                  _context4.t0 = _context4['catch'](1);

                  _this2._onError('hydrate.run_script', name, _context4.t0);

                  return _context4.abrupt('return', false);

                case 24:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, _this2, [[1, 20]]);
        }));

        return function (_x7) {
          return _ref5.apply(this, arguments);
        };
      }();
    };

    this._unmount = function (appName, eventTitle) {
      return function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(resolvedFragment) {
          var script, name, slot, slotElement, app;
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  script = resolvedFragment.script, name = resolvedFragment.name, slot = resolvedFragment.slot;
                  _context5.prev = 1;
                  slotElement = _this2._getSlotElement(slot);

                  if (slotElement) {
                    _context5.next = 6;
                    break;
                  }

                  _this2._onError('unmount.missing', slot);

                  return _context5.abrupt('return', false);

                case 6:
                  if (!(typeof script.unmount !== 'function')) {
                    _context5.next = 9;
                    break;
                  }

                  _this2._onError('unmount.invalid_script', name || appName);

                  return _context5.abrupt('return', false);

                case 9:
                  app = _this2._apps[appName];

                  if (!(script.version === 3)) {
                    _context5.next = 15;
                    break;
                  }

                  _context5.next = 13;
                  return script.unmount(slotElement, w.history, app);

                case 13:
                  _context5.next = 17;
                  break;

                case 15:
                  _context5.next = 17;
                  return script.unmount(slotElement, eventTitle, app);

                case 17:
                  return _context5.abrupt('return', true);

                case 20:
                  _context5.prev = 20;
                  _context5.t0 = _context5['catch'](1);

                  _this2._onError('unmount.error', name || appName, _context5.t0);

                  return _context5.abrupt('return', false);

                case 24:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, _this2, [[1, 20]]);
        }));

        return function (_x8) {
          return _ref6.apply(this, arguments);
        };
      }();
    };

    this._mount = function (appName, eventTitle) {
      return function () {
        var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(resolvedFragment) {
          var script, name, slot, slotElement, app;
          return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  script = resolvedFragment.script, name = resolvedFragment.name, slot = resolvedFragment.slot;
                  _context6.prev = 1;
                  slotElement = _this2._getSlotElement(slot);

                  if (slotElement) {
                    _context6.next = 6;
                    break;
                  }

                  _this2._onError('mount.missing', name || appName);

                  return _context6.abrupt('return', false);

                case 6:
                  if (!(typeof script.mount !== 'function')) {
                    _context6.next = 9;
                    break;
                  }

                  _this2._onError('mount.invalid_script', name || appName);

                  return _context6.abrupt('return', false);

                case 9:
                  app = _this2._apps[appName];

                  if (!(script.version === 3)) {
                    _context6.next = 15;
                    break;
                  }

                  _context6.next = 13;
                  return script.mount(slotElement, w.history, app);

                case 13:
                  _context6.next = 17;
                  break;

                case 15:
                  _context6.next = 17;
                  return script.mount(slotElement, eventTitle, app);

                case 17:
                  return _context6.abrupt('return', true);

                case 20:
                  _context6.prev = 20;
                  _context6.t0 = _context6['catch'](1);

                  _this2._onError('mount.error', name || appName, _context6.t0);

                  return _context6.abrupt('return', false);

                case 24:
                case 'end':
                  return _context6.stop();
              }
            }
          }, _callee6, _this2, [[1, 20]]);
        }));

        return function (_x9) {
          return _ref7.apply(this, arguments);
        };
      }();
    };

    this._onStateChange = function (appName, eventTitle) {
      return function () {
        var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(resolvedFragment) {
          var script, name, app;
          return _regenerator2.default.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  script = resolvedFragment.script, name = resolvedFragment.name;
                  _context7.prev = 1;

                  if (!(typeof script.onStateChange !== 'function')) {
                    _context7.next = 5;
                    break;
                  }

                  _this2._onError('on_state_change.invalid_script', name || appName);

                  return _context7.abrupt('return', false);

                case 5:
                  app = _this2._apps[appName];

                  if (!(script.version === 3)) {
                    _context7.next = 11;
                    break;
                  }

                  _context7.next = 9;
                  return script.onStateChange(w.history, app);

                case 9:
                  _context7.next = 13;
                  break;

                case 11:
                  _context7.next = 13;
                  return script.onStateChange(eventTitle, app);

                case 13:
                  return _context7.abrupt('return', true);

                case 16:
                  _context7.prev = 16;
                  _context7.t0 = _context7['catch'](1);

                  _this2._onError('on_state_change.error', name || appName, _context7.t0);

                  return _context7.abrupt('return', false);

                case 20:
                case 'end':
                  return _context7.stop();
              }
            }
          }, _callee7, _this2, [[1, 16]]);
        }));

        return function (_x10) {
          return _ref8.apply(this, arguments);
        };
      }();
    };

    this._onUpdateStatus = function (appName, status) {
      return function () {
        var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(resolvedFragment) {
          var script, name, app;
          return _regenerator2.default.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  script = resolvedFragment.script, name = resolvedFragment.name;

                  if (!(script.version === 3)) {
                    _context8.next = 3;
                    break;
                  }

                  return _context8.abrupt('return', true);

                case 3:
                  _context8.prev = 3;

                  if (!(typeof script.onUpdateStatus !== 'function')) {
                    _context8.next = 7;
                    break;
                  }

                  _this2._onError('on_update_status.invalid_script', name || appName);

                  return _context8.abrupt('return', false);

                case 7:
                  app = _this2._apps[appName];
                  _context8.next = 10;
                  return script.onUpdateStatus(status, app);

                case 10:
                  return _context8.abrupt('return', true);

                case 13:
                  _context8.prev = 13;
                  _context8.t0 = _context8['catch'](3);

                  _this2._onError('on_update_status.error', name || appName, _context8.t0);

                  return _context8.abrupt('return', false);

                case 17:
                case 'end':
                  return _context8.stop();
              }
            }
          }, _callee8, _this2, [[3, 13]]);
        }));

        return function (_x11) {
          return _ref9.apply(this, arguments);
        };
      }();
    };

    this._hydratePage = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
      var currentAppName, resolvedFragments, hydratePromises, hydrateSuccess;
      return _regenerator2.default.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              currentAppName = _this2._currentAppName;

              if (currentAppName) {
                _context9.next = 4;
                break;
              }

              _this2._onError('hydrate_page.missing_route');

              return _context9.abrupt('return', false);

            case 4:
              _context9.prev = 4;
              _context9.next = 7;
              return _this2._resolvePageFragments(currentAppName);

            case 7:
              resolvedFragments = _context9.sent;

              if (!(!Array.isArray(resolvedFragments) || !resolvedFragments.every(Boolean))) {
                _context9.next = 10;
                break;
              }

              return _context9.abrupt('return', false);

            case 10:
              hydratePromises = resolvedFragments.map(_this2._hydrate(currentAppName));
              _context9.next = 13;
              return _promise2.default.all(hydratePromises);

            case 13:
              hydrateSuccess = _context9.sent;
              return _context9.abrupt('return', hydrateSuccess.every(Boolean));

            case 17:
              _context9.prev = 17;
              _context9.t0 = _context9['catch'](4);

              _this2._onError('hydrate_page.get_scripts', currentAppName, _context9.t0);

              return _context9.abrupt('return', false);

            case 21:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, _this2, [[4, 17]]);
    }));

    this._updatePage = function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(newAppName, eventTitle) {
        var oldAppName, _ref12, _ref13, oldResolvedFragments, newResolvedFragments, oldFragmentNames, newFragmentNames, unmountPromises, mountPromises, onStateChangePromises, unmountSuccess, mountSuccess, onStateChangeSuccess;

        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                oldAppName = _this2._currentAppName;

                if (oldAppName) {
                  _context10.next = 4;
                  break;
                }

                _this2._onError('update_page.no_current_app');

                return _context10.abrupt('return', false);

              case 4:
                _context10.next = 6;
                return _promise2.default.all([_this2._resolvePageFragments(oldAppName), _this2._resolvePageFragments(newAppName)]);

              case 6:
                _ref12 = _context10.sent;
                _ref13 = (0, _slicedToArray3.default)(_ref12, 2);
                oldResolvedFragments = _ref13[0];
                newResolvedFragments = _ref13[1];

                if (!(!Array.isArray(oldResolvedFragments) || !Array.isArray(newResolvedFragments) || !oldResolvedFragments.every(Boolean) || !newResolvedFragments.every(Boolean))) {
                  _context10.next = 13;
                  break;
                }

                _this2._onError('update_page.invalid_fragments');

                return _context10.abrupt('return', false);

              case 13:
                oldFragmentNames = oldResolvedFragments.map(function (_ref14) {
                  var name = _ref14.name;
                  return name;
                });
                newFragmentNames = newResolvedFragments.map(function (_ref15) {
                  var name = _ref15.name;
                  return name;
                });
                unmountPromises = oldResolvedFragments.filter(function (resolvedFragment) {
                  return newFragmentNames.indexOf(resolvedFragment.name) === -1;
                }).map(_this2._unmount(oldAppName, eventTitle));
                mountPromises = newResolvedFragments.filter(function (resolvedFragment) {
                  return oldFragmentNames.indexOf(resolvedFragment.name) === -1;
                }).map(_this2._mount(newAppName, eventTitle));
                onStateChangePromises = oldResolvedFragments.filter(function (resolvedFragment) {
                  return newFragmentNames.indexOf(resolvedFragment.name) > -1;
                }).map(_this2._onStateChange(newAppName, eventTitle));
                _context10.next = 20;
                return _promise2.default.all(unmountPromises);

              case 20:
                unmountSuccess = _context10.sent;

                if (unmountSuccess.every(Boolean)) {
                  _context10.next = 23;
                  break;
                }

                return _context10.abrupt('return', false);

              case 23:
                _context10.next = 25;
                return _promise2.default.all(mountPromises);

              case 25:
                mountSuccess = _context10.sent;

                if (mountSuccess.every(Boolean)) {
                  _context10.next = 28;
                  break;
                }

                return _context10.abrupt('return', false);

              case 28:
                _context10.next = 30;
                return _promise2.default.all(onStateChangePromises);

              case 30:
                onStateChangeSuccess = _context10.sent;
                return _context10.abrupt('return', onStateChangeSuccess.every(Boolean));

              case 32:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, _this2);
      }));

      return function (_x12, _x13) {
        return _ref11.apply(this, arguments);
      };
    }();

    this._handleStateChange = function () {
      var _ref16 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(eventTitle) {
        var newAppName, updatePageSuccess;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if (!(_this2._status !== _this2.constructor.statuses.DEFAULT)) {
                  _context11.next = 3;
                  break;
                }

                _this2.constructor._goToPath();

                return _context11.abrupt('return', false);

              case 3:
                if (!(typeof eventTitle !== 'string')) {
                  _context11.next = 6;
                  break;
                }

                _this2._onError('handle_state_change.invalid_event_title');

                return _context11.abrupt('return', false);

              case 6:

                _this2._setStatus(_this2.constructor.statuses.LOADING);

                newAppName = _this2._getAppFromPath();

                if (newAppName) {
                  _context11.next = 12;
                  break;
                }

                _this2._onError('handle_state_change.app_not_found');
                _this2.constructor._goToPath();

                return _context11.abrupt('return', false);

              case 12:
                _context11.prev = 12;
                _context11.next = 15;
                return _this2._updatePage(newAppName, eventTitle);

              case 15:
                updatePageSuccess = _context11.sent;

                if (updatePageSuccess) {
                  _context11.next = 20;
                  break;
                }

                _this2._setStatus(_this2.constructor.statuses.ERROR);
                _this2.constructor._goToPath();

                return _context11.abrupt('return', false);

              case 20:

                _this2._currentAppName = newAppName;
                _this2._setStatus(_this2.constructor.statuses.DEFAULT);

                return _context11.abrupt('return', true);

              case 25:
                _context11.prev = 25;
                _context11.t0 = _context11['catch'](12);

                _this2._onError('handle_state_change', newAppName, _context11.t0);
                _this2.constructor._goToPath();

                return _context11.abrupt('return', false);

              case 30:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, _this2, [[12, 25]]);
      }));

      return function (_x14) {
        return _ref16.apply(this, arguments);
      };
    }();

    this._handleUpdateStatus = function () {
      var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(status) {
        var currentAppName, resolvedFragments, updateStatusPromises, updateStatusSuccess;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                currentAppName = _this2._currentAppName;

                if (currentAppName) {
                  _context12.next = 3;
                  break;
                }

                return _context12.abrupt('return', false);

              case 3:
                if (!(typeof status !== 'string')) {
                  _context12.next = 5;
                  break;
                }

                return _context12.abrupt('return', false);

              case 5:
                _context12.prev = 5;
                _context12.next = 8;
                return _this2._resolvePageFragments(currentAppName);

              case 8:
                resolvedFragments = _context12.sent;

                if (!(!Array.isArray(resolvedFragments) || !resolvedFragments.every(Boolean))) {
                  _context12.next = 11;
                  break;
                }

                return _context12.abrupt('return', false);

              case 11:
                updateStatusPromises = resolvedFragments.map(_this2._onUpdateStatus(currentAppName, status));
                _context12.next = 14;
                return _promise2.default.all(updateStatusPromises);

              case 14:
                updateStatusSuccess = _context12.sent;
                return _context12.abrupt('return', updateStatusSuccess.every(Boolean));

              case 18:
                _context12.prev = 18;
                _context12.t0 = _context12['catch'](5);

                _this2._onError('handle_update_status', currentAppName, _context12.t0);

                return _context12.abrupt('return', false);

              case 22:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, _this2, [[5, 18]]);
      }));

      return function (_x15) {
        return _ref17.apply(this, arguments);
      };
    }();

    this.init = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13() {
      var currentAppName, hydrateSuccess;
      return _regenerator2.default.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _this2._shimHistory();

              _this2._setStatus(_this2.constructor.statuses.LOADING);

              if ((0, _keys2.default)(_this2._slots).every(function (slotName) {
                return _this2._getSlotElement(slotName);
              })) {
                _context13.next = 5;
                break;
              }

              _this2._onError('init.missing_elements');

              return _context13.abrupt('return', false);

            case 5:
              currentAppName = _this2._getAppFromPath();

              if (currentAppName) {
                _context13.next = 9;
                break;
              }

              _this2._onError('init.no_route');

              return _context13.abrupt('return', false);

            case 9:

              _this2._currentAppName = currentAppName;

              _context13.next = 12;
              return _this2._hydratePage();

            case 12:
              hydrateSuccess = _context13.sent;

              if (hydrateSuccess) {
                _context13.next = 16;
                break;
              }

              _this2._setStatus(_this2.constructor.statuses.ERROR);

              return _context13.abrupt('return', false);

            case 16:

              _this2._setStatus(_this2.constructor.statuses.DEFAULT);

              return _context13.abrupt('return', true);

            case 18:
            case 'end':
              return _context13.stop();
          }
        }
      }, _callee13, _this2);
    }));
  }, _temp;
}